<template>
  <li class="products__item">
    <div class="products__title">{{ product.title }} <div v-if="this.product.inventory < 10"><span>Количество ограничено</span></div></div>
    <div class="products__count"><button @click="decrementItemQuantity">-</button><span>{{ product.quantity }}</span><button @click="incrementItemQuantity" :disabled="disabled">+</button></div>
    <div class="products__price"><Price :price="price" /> / шт.</div>
    <div class="products__button"><button @click="removeProduct">Удалить</button></div>
  </li>
</template>

<script>
import Price from '@/components/Price'

export default {
  name: 'CartItem',
  props: {
    product: {
      required: true,
      type: Object
    }
  },
  components: {
    Price
  },
  computed: {
    price () {
      return this.$store.getters['products/price'](this.product)
    },
    disabled () {
      return !this.product.inventory
    }
  },
  methods: {
    removeProduct () {
      this.$store.dispatch('cart/removeProduct', this.product)
    },
    incrementItemQuantity () {
      this.$store.commit('cart/incrementItemQuantity', this.product)
      this.$store.commit('products/decrementProductInventory', this.product)
    },
    decrementItemQuantity () {
      if (this.product.quantity < 2) {
        this.removeProduct()
      } else {
        this.$store.commit('cart/decrementItemQuantity', this.product)
        this.$store.commit('products/incrementProductInventory', this.product)
      }
    }
  }
}
</script>
